# List projects

> Management API · Projects

```http
GET https://app.mk.io/api/v1/projects
```

## Listing, Sorting and Filtering Projects

This endpoint returns the list of projects.

### Sorting

The results from this endpoint can be ordered using the `$orderby` query parameter. Specify a list of field names, separated by commas
where each one can optionally specify `asc` or `desc`.

Sorting is valid on the following fields: `assignedPaymentMethodId`, `created`, `createdBy`, `displayName`, `id`, `isActive`, `locationId`, `name`, `updated`

### Filtering

The `$filter` query parameter allows for projects to be filtered on the basis of fields in the schema using OData query syntax.
See [this document](https://learn.microsoft.com/en-us/odata/concepts/queryoptions-overview#filter) for more details on the syntax used.

Filters are valid on the following fields: `assignedPaymentMethodId`, `created`, `createdBy`, `createdByEmail`, `createdByName`, `displayName`, `id`, `isActive`, `locationId`, `locationName`, `name`, `updated`

### Examples:

`?$top=10` - Returns only the first 10 projects from the list.

`?$orderby=name desc` - Sorts projects by name in descending order.

`?$filter=name eq 'descriptive name'` - Returns projects that match the provided name.

`?$orderby=created desc` - Sorts projects by creation date in descending order.

`?$filter=created ge 2021-01-01T00:00:00Z` - Returns projects created after January 1, 2021.

RBAC Capability Required: `core.project.get`

## Authentication

- `Authorization` header — Bearer authentication of the form `Bearer <token>`.

## Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `$orderby` | string | No | Specifies the key by which the result collection should be ordered. |
| `$filter` | string | No | Restricts the set of items returned. |
| `$top` | string | No | Specifies a non-negative integer `n` that limits the number of items returned from a collection. The service returns the number of available items up to but not greater than the specified value `n`. |
| `$skiptoken` | string | No | Specifies a start offset to support paginated results. Use `@odata.nextLink` in the result object to enumerate the collection - it will be present only if there's more than one page of entities. |
| `show_hidden` | string | No | Shows hidden projects if present. |

## Example request

```bash
curl -X GET "https://app.mk.io/api/v1/projects" \
  -H "Authorization: Bearer <token>"
```

## Responses

### 200 — OK

- `@odata.nextLink` · string · Optional — @odata.nextLink URL if the page length and number of items match.
- `supplemental` · object · **Required** — Supplemental info
  - `count` · integer · **Required** — Number of items returned
  - `kind` · string · **Required** — Type of items in the list
  - `operation` · string · **Required** — Operation type. Should always say 'list'
  - `pagination` · object · **Required** — Pagination info
    - `end` · integer · **Required** — Position of the last item in the list
    - `records` · integer · **Required** — Total number of items returned in the list
    - `start` · integer · **Required** — Position of the first item in the list
    - `total` · integer · **Required** — Total number of items in the project
  - `subscription` · object · Optional — Project info
    - `id` · string · **Required** — Project ID
    - `name` · string · **Required** — Project name
- `value` · list of objects · **Required** — List of projects the user has access to within this organization.
  - Array items (object):
    - `kind` · string · Optional — The kind of record.
    - `metadata` · object · Optional — Metadata.
      - `cloud` · object · **Required** — Cloud in which the project is hosted.
        - `displayName` · string · **Required** — The display name of the cloud.
        - `id` · string · Optional · _format: uuid_ — The unique identifier of the cloud.
        - `name` · string · **Required** — The unique name of the cloud.
      - `created` · string · Optional · _format: date-time_ — The time when the resource was created
      - `createdBy` · string · Optional · _format: uuid_ — ID of the user who created the resource
      - `createdByEmail` · string · Optional — Email of the user who created the resource
      - `createdById` · string · **Required** · _format: uuid_ — ID of the user who created the project.
      - `createdByName` · string · **Required** — Name of the user who created the project.
      - `displayName` · string · Optional — The display name of the resource
      - `id` · string · **Required** · _format: uuid_ — The ID of the resource
      - `name` · string · Optional — The name of the resource
      - `updated` · string · Optional · _format: date-time_ — The time when the resource was last updated
    - `spec` · object · **Required** — Specification.
      - `assignedPaymentMethodId` · string or null · **Required** · _format: uuid_ — ID of the payment method assigned to the project.
      - `displayName` · string · **Required** — Display name of the project.
      - `isActive` · boolean · **Required** — Is project active.
      - `locationDisplayName` · string · Optional — Display name of the location the project is in.
      - `locationId` · string · **Required** · _format: uuid_ — ID of the location the project is in.
      - `locationName` · string · **Required** — Name of the location the project is in.
      - `name` · string · **Required** — Name of the project.

Example:

```json
{
  "@odata.nextLink": "string",
  "supplemental": {
    "count": 0,
    "kind": "string",
    "operation": "string",
    "pagination": {
      "end": 0,
      "records": 0,
      "start": 0,
      "total": 0
    },
    "subscription": {
      "id": "string",
      "name": "string"
    }
  },
  "value": [
    {
      "kind": "string",
      "metadata": {
        "cloud": {
          "displayName": "Azure",
          "id": "00000000-0000-0000-0000-000000000000",
          "name": "azure"
        },
        "created": "2024-01-01T00:00:00Z",
        "createdBy": "00000000-0000-0000-0000-000000000000",
        "createdByEmail": "string",
        "createdById": "00000000-0000-0000-0000-000000000000",
        "createdByName": "string",
        "displayName": "string",
        "id": "00000000-0000-0000-0000-000000000000",
        "name": "string",
        "updated": "2024-01-01T00:00:00Z"
      },
      "spec": {
        "assignedPaymentMethodId": "00000000-0000-0000-0000-000000000000",
        "displayName": "string",
        "isActive": true,
        "locationDisplayName": "string",
        "locationId": "00000000-0000-0000-0000-000000000000",
        "locationName": "string",
        "name": "string"
      }
    }
  ]
}
```

### 400 — Bad Request

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 401 — Unauthorized

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 403 — Forbidden

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 404 — Not Found

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 429 — Too Many Requests

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

### 500 — Internal Server Error

- `error` · object · **Required** — Pertinent information about the error
  - `code` · string · **Required** — The error code.
  - `detail` · string · **Required** — The error message.
  - `extraDetail` · map from strings to any · Optional — Extra information regarding this error.
    - `[any key]` · any — map of additional properties
- `ref` · string · **Required** — A reference to the request that caused the error.
- `status` · integer · **Required** — The HTTP status code

Example:

```json
{
  "error": {
    "code": "string",
    "detail": "string",
    "extraDetail": {
      "key": null
    }
  },
  "ref": "string",
  "status": 0
}
```

---

Source spec: `management-api` · operationId: `[get]_/api/v1/projects`
